<?php
error_reporting(0);
/*
	@description API WRAPPER for Cron
	@author Tomex Evaristo Dec 31 2019	
*/
if(!class_exists('CRONWRAP'))
{
	class CRONWRAP
	{

		private $ExistingCronRUles 		= '';
		private $TmpCronFIle 			= '/tmp/crontab.txt';
		private $FinCronFIle 			= '/tmp/fin.crontab.txt';
		private $BCKCronFIle 			= '';
		private $SMSGcronmarker			= '###SMSGmrker-';
		private $InputedRules			= array();
		private $FinalCronRUles			= array();
		private $output_message			= '';

		public function __construct(){
			$backupCronCMD 	= "crontab -l > {$this->TmpCronFIle}";
			shell_exec($backupCronCMD);
		}
		
		public function createRule($time = '',$command = '',$key = '')
		{
			$key = str_replace(' ', '', $key);
			$this->InputedRules[$key]['time'] = trim($time);
			$this->InputedRules[$key]['cmd']  = trim($command);
			return $this;
		}

		/*
			@string $time crontab rule
			@string $key Unique Key to mark as cron entry
			@string $path path to command ir command
		*/
		public function run(){
			$this->FinalCronRUles[] = '## Parsed by smsg cron api on '.date('Y-m-d H:i:s');
			if(file_exists($this->TmpCronFIle))
			{
				$fp=fopen($this->TmpCronFIle, 'r');
				while (!feof($fp))
				{
				    $line=fgets($fp);
				    $this->processCronEntry($line);									    			    
				}
				fclose($fp);
			
				$this->processRemainingEntry();

				file_put_contents($this->FinCronFIle, implode(PHP_EOL, $this->FinalCronRUles));	
				$this->output_message =  "new file was saved to {$this->FinCronFIle}";
			}else{
				$this->output_message = "Unable to access crontab file {$this->TmpCronFIle}";
			}
		}
		public function output(){
			return $this->output_message;
		}

		public function save(){
			$COMMAND = "crontab {$this->FinCronFIle}";
			$this->output_message =  $COMMAND;
			//shell_exec($COMMAND);
		}

		private function processCronEntry($line)
		{
			$line = trim($line);
			if(strpos($line, $this->SMSGcronmarker) === false)
			{
				//Current Rule is not created using our api
				$this->FinalCronRUles[] = $line;
			}else{
				$KEY_STUB = strpos( $line , $this->SMSGcronmarker );
				$MarkerData = substr($line,$KEY_STUB);
				$GETKEY = explode('-',$MarkerData);
				$_KEY = trim($GETKEY[1]);
				//current rule is created using Cronentry API

				if(array_key_exists($_KEY, $this->InputedRules))
				{
					$newRule = $this->InputedRules[$_KEY];
					//key exist on input update our config
					$time = $newRule['time'];
					$cmd  = $newRule['cmd'];
					$key  = $this->SMSGcronmarker.$_KEY;
					$this->FinalCronRUles[] = $time." ".$cmd." ".$key;
					unset($this->InputedRules[$_KEY]);
				}else{
					$this->FinalCronRUles[] = $line;
				}
			}		
		}

		private function processRemainingEntry()
		{
			if(count($this->InputedRules) >= 1)
			{
				foreach($this->InputedRules as $key => $value){
					$this->FinalCronRUles[] = $value['time']." ".$value['cmd']." ".$this->SMSGcronmarker.$key;
				}
			}
			return $this;
		}
	}
}
/*
	//USE CASE
	//Initialize Class
	$cron = new CRONWRAP;

	//create rules first param is time, 2nd param is pathor command , 3rd param is a unique keymarker to be used
	//to identify this rule when editin
	$cron->createRule('1 * * * *','php /var/www/test/phpfile1','KEY1');
	$cron->createRule('2 * * * *','php /var/www/test/phpfile2','KEY2');
	$cron->createRule('2 * * 4 *','php /var/www/test/phpfile2','key14');

	//run api
	//data will be saved to a temporary file
	// /tmp/tmp/fin.crontab.txt' in this case you can check if the parser did it right
	$cron->run();

	//this will save the new data to the cron 
	$cron->save();

	//show the last output message
	// echo $cron->output();
*/