<?php
define('SMSG_IS_INCLUDED',true);
require_once '/www/cgi-bin/firewall/config.php';

//Include Dependencies when changes has been detected
if(Applyrules::ConfigHasChanges())
{
	include_once API_CONFIG_FILE_PATH;
	/* 
		INCLUDE_once DEPENDENCIES
	*/

	if(DNSFILTER_USEURL === false)
	{	
		include_once DNSFILTER_PATH;	
	}

	if(NETWORK_USEURL === false)
	{
		include_once NETWORK_PATH;
	}
}

class HTML_CREATE
{
	private $template_comment = "<!-- firewall/applyrules HTML_CREATE File is generated automatically. all updates will be overwritten once sync is applied -->".PHP_EOL;

	private $CONFIG = false;
	private $LOCK_FILE_DATA;


	public function get_config()
	{
		if(file_exists(HTML_LOCK_FILE))
		{
			$lockfileData = json_decode(@file_get_contents(HTML_LOCK_FILE),true);
			$this->CONFIG = $lockfileData;
		}
		return $this;
	}

	public function parseConfig($key)
	{
		return isset($this->CONFIG[$key]) ? $this->CONFIG[$key] : false;
	}


	function buildLockFile(){
		file_put_contents(HTML_LOCK_FILE,json_encode($this->LOCK_FILE_DATA));
	}

	function wan_portforward($wan,$portforward)
	{
		$lockfileHash = $this->parseConfig('WANPRTFWRD_HTML');
		$newHash = md5($wan,$portforward);

		if($lockfileHash == $newHash){
			$this->LOCK_FILE_DATA['WANPRTFWRD_HTML'] = $lockfileHash;
			$msg = 'No changes to Domain Filtering';
		}else{
			
		}
	}

	function domainfilter($domains,$blocking,$BLOCK_OS_IS_ENABLED)
	{
		$lockfileHash = $this->parseConfig('DOMFILTER_HTML');
		$newHash = md5($domains.$blocking,$BLOCK_OS_IS_ENABLED);
		if($newHash == $lockfileHash)
		{
			$this->LOCK_FILE_DATA['DOMFILTER_HTML'] = $lockfileHash;
			$msg = 'No changes to Domain Filtering';
		}else
		{
			$msg = 'Changes to Domain Filtering was saved';
			$this->LOCK_FILE_DATA['DOMFILTER_HTML'] = $newHash;
			$blocking_label = $blocking == 'B' ? 'Domain Whitelist' : 'Domain Blacklist';
			$domains = array_filter(explode(';',$domains));
			$DELIMITER = 'USRINPT-';
			$template = '';
			$template .= $this->template_comment;	
			$template .= "<span><input type=\"checkbox\" ".($blocking == 'A' ? 'checked' : '')." disabled readonly> Allow All</span><br>";				
			$template .= "<span><input type=\"checkbox\" ".($blocking == 'B' ? 'checked' : '')." disabled readonly> Block All</span>";
			
			
			$template .= "<table style=\"width:97%;padding:0;margin-bottom:100px;float:right\">";	
			$template .= "<tr><td>{$blocking_label}</td><td></td></tr>";
			if($blocking == 'A' && $BLOCK_OS_IS_ENABLED == 1){
				$template .= '<tr><td><input type="checkbox" checked disabled readonly> Block OS Domains</td><td></td></tr>';				
			}
			
			
			if(count($domains) >= 1)
			{		
				$template .= "<tr>";	
				$counter = 0;
				foreach($domains as $k => $filteredDoms)
				{		
					// $search_res = strpos(trim(strtoupper($filteredDoms)),$search) >= 0;		
					$has = 0;
					$search_res = strpos(trim(strtoupper($filteredDoms)), $DELIMITER);
					if($search_res === false){
						//do nothing
					}else
					{
						$filteredDoms = substr($filteredDoms, strlen($DELIMITER));
						$template .= "<td><input type=\"text\" style=\"width:100%\" value=\"{$filteredDoms}\" disabled readonly></td>";
						$counter++;
					}

					if($counter > 0 && $counter % 2 == 0){
						$template .= "</tr><tr>";
					}
				}
			}

			$template .= "</tr></table>";			

			file_put_contents(DOMFILTER_HTML,$template);
		}

		return $msg;
	}

	function firewall($IPS,$PORTS,$fwstate)
	{
		$lockfileHash = $this->parseConfig('FIREWALL_HTML');
		$newHash = md5($IPS.$PORTS.$fwstate);
		if($newHash == $lockfileHash)
		{
			$this->LOCK_FILE_DATA['FIREWALL_HTML'] = $lockfileHash;
			$msg = 'No Changes to Firewall';
		}else
		{	
			$msg = 'Changes to Firewall was saved';
			$this->LOCK_FILE_DATA['FIREWALL_HTML'] = $newHash;
			$label  = strtoupper($fwstate) == "A" ? "Blocked" : "Open";
		    $title   = strtoupper($fwstate) == "A" ? "Allow All" : "Close All";
			$IPS 	= $IPS;
			$PORTS 	= $PORTS;
			$template = "";
			$template .= $this->template_comment;
		    $template .="<strong>$title</strong><br>";
		    if(strlen($IPS) >= 1){		    	
				$template .= "<p>$label Ip Address:</p>";
				$ipsArr = array_filter(explode(';',$IPS));
		        $template.= "<ul>";
		        foreach($ipsArr as $ipval){
		        	$IP_PORT = explode('|',$ipval);

		        	$IP = 0;
		        	if($IP_PORT[2] != 0){
		        		$IP = $this->_hex2ip($IP_PORT[2]);
		        	}

		        	$PORT = 0;
		        	if($IP_PORT[3] != 0){
		        		$PORT = $this->_hex2port($IP_PORT[3]);
		        	}
		        	$PORT = $PORT == 0 ? '' : ':'.$PORT;
		            $template.= "<li>{$IP} {$PORT}</>";
		        }
		        $template .= "</ul>";        
			}else{		
		        $template .= "<p>$label Ip Address:";
				$template .= "<ul><li><i>No IP</i></li></ul>";
			}

			if(strlen($PORTS) >= 1){
				$template .= "<p>$label Port:</p>";
		        $prtArr = array_filter(explode(';',$PORTS));
		        $template.= "<ul>";
		        foreach($prtArr as $prtval){
		            $template.= "<li>$prtval</>";
		        }
		        $template .= "</ul>";
		        $template .= "</p>";
			}else{
		        $template .= "<p>$label Ports:";
				$template .= "<ul><li><i>No Port</i></li></ul>";
			}	

			file_put_contents(FIREWALL_HTML,$template);
		}
		return $msg;
	}

	function apps($APPS_JSON_FORMAT,$firewall_status)
	{
		$lockfileHash = $this->parseConfig('APPLICATIONS_HTML');
		$newHash = md5($APPS_JSON_FORMAT);
		if($newHash == $lockfileHash)
		{
			$this->LOCK_FILE_DATA['APPLICATIONS_HTML'] = $lockfileHash;
			$msg = 'No changes IM APPS';
		}else
		{	
			$msg = 'Changes to IM APPS was saved';
			$this->LOCK_FILE_DATA['APPLICATIONS_HTML'] = $newHash;		
			$APPS = json_decode($APPS_JSON_FORMAT,true);
		    if(count($APPS) >= 1)
		    {
		        $html = '';
		        $html .= $this->template_comment;
		        $html .="<strong>Allowed Applications</strong>";
		        $html .= "<ul>";
		        foreach($APPS as $app_key => $app_val){
		            $html .= "<li>";
		            $html .= "<strong>".$app_val['name']."</strong><br>";

		            if(count($app_val['label']) >= 1){
		                foreach($app_val['label'] as $app_label_k => $app_label_v){
		                    $html .= "<input type=\"checkbox\" checked disabled>$app_label_v<br>";
		                }
		            }
		            $html .= "</li>";
		        }
		        $html .= "</ul>";        
		        file_put_contents(APPLICATIONS_HTML,$html);
		        @chmod(APP_HTML,0755);
		    }else{
		    	if(strtoupper($firewall_status) == 'A')
		    	{
		    		file_put_contents(APPLICATIONS_HTML,'<p>All Applications allowed</p>');
		    	}else{
		    		file_put_contents(APPLICATIONS_HTML,'<p>No Apps Selected</p>');	
		    	}		        
		    }
		}

		return $msg;
	}

	function CaptivePortalBypass($CAPTIVE_PORTAL_BYPASS = '')
	{
		$lockfileHash = $this->parseConfig('CPB_HTML');
		$newHash = md5($CAPTIVE_PORTAL_BYPASS);
		if($newHash == $lockfileHash)
		{
			$this->LOCK_FILE_DATA['CPB_HTML'] = $lockfileHash;
			$msg = 'No Changes to Captive Portal Bypass';
		}else
		{	
			$this->LOCK_FILE_DATA['CPB_HTML'] = $newHash;		
			$msg = 'Changes to Captive Portal Bypass was saved';
			$template = '';
			$template .= $this->template_comment;
			$template .= "<p><strong>Allowed IPs</strong></p>";
			$template .= "<table style=\"width:100%;padding:0;margin:0\">";
			$template .= "<tr><td>Alias</td><td>IP Address</td></tr>";
			if(strlen($CAPTIVE_PORTAL_BYPASS) >= 1)
			{
				$parse_as_array = array_filter(explode(';',$CAPTIVE_PORTAL_BYPASS));
				if(count($parse_as_array) >= 1)
				{
					foreach($parse_as_array as $key =>$domains)
					{				
						if(strpos($domains, 'DEF-') === false){
							$template .= "<tr>";
							$template .= "<td><input type=\"text\" style=\"width:100%\" value=\"\" disabled readonly></td><td><input type=\"text\" style=\"width:100%\" value=\"{$domains}\" disabled readonly></td>";
							$template .= "</tr>";
						}
					}
				}
			}
			$template .= "</table>";
			file_put_contents(CPB_HTML,$template);
		}

		return $msg;
	}

	private function _hex2ip($hex)
	{
		$tmp = $hex[0] . $hex[1];
		$ip = hexdec($tmp) . ".";
		
		$tmp = $hex[2] . $hex[3];
		$ip .= hexdec($tmp) . ".";
		
		$tmp = $hex[4] . $hex[5];
		$ip .= hexdec($tmp) . ".";
		
		$tmp = $hex[6] . $hex[7];
		$ip .= hexdec($tmp);
		
		if (strlen($hex) > 8)  $ip .= substr($hex, 8);
		
		return $ip;
	}

	private function _hex2port($port){
		if(strpos($port, ',') !== false)
		{
			//is multiple
			$exploded = explode(':', $port);
			$tmp = array();
			foreach($port as $pk => $pv)
			{
				$tmp[] = hexdec($pv);
			}
			$portParsed = implode(',',$tmp);
		}else if(strpos($port, ':') !== false)
		{
			$exploded = explode(':', $port);
			$portParsed = hexdec($exploded[0]).':'.hexdec($exploded[1]);
			//is range
		}else if($port != 0){
			$portParsed = hexdec($port);
		}else{
			$portParsed = 0;
		}

		return $portParsed;
	}
}

class Output{

	static function jsonMessage($status,$message = ''){
		header('Content-type: application/json');
		echo json_encode(array('status'=>$status,'message' => $message));
		exit;
	}

	static function json($message){
		header('Content-type: application/json');
		echo json_encode($message);
		exit;
	}
}


class Applyrules{

	private $DEBUG 				= true;
	private $EXECUTE 			= true;
	private $CONTINUE_PROCESS	= false;
	private $LOG_PROCESS		= true;
	private $CONFIG;
	private $DOMAIN_FILTERING 	=  'B';
	private $cleanFW			= ''; //holds BIZ firewall rules
	private $cleanPF			= ''; //holds BIZ FOrward Rules
	private $cleanIPS			= ''; //holds crew rules for allowed or blocked IPS
	private $cleanIMFW  		= ''; //holds rules for imapps
	private $cleanPORTS 		= ''; //holds crew rules for allowed or blocked ports
	private $cleanDOM 			= ''; //holds crew rules for allowed or blocked domains
	private $cleanCPB			= ''; //holds domains for captive portal bypass settings
	private $cleanBLOCKOS 		= ''; //holds domains when block os is enabled	
	private $CONFIG_CLEAN		= array();

	private $ACFW_USEURL			= false;
	private $APICALL_RESULT_MSG = array();
	private $CURRENT_CONFIG_HASH = false;
	private $BLOCK_OS_IS_ENABLED = false;	

	public function __construct()
	{
		$this->tagLastKnowServerAddr();
		$this->getConfig();
		$this->_prepVariables();		
	}

	private function getConfig(){
		$this->CONFIG = false;

		$synced 	= @json_decode(@file_get_contents( SYNCAPPLY_INI ),true);
		$applied 	= @json_decode(@file_get_contents( APPLIED_RULES ),true);

		if($synced['hash'] == $applied['hash'])
		{
			$this->OUTPUT['loadingConfig'] = 'Loading Already Applied Config';
			$this->CONFIG = $applied;
		}else{
			$this->OUTPUT['loadingConfig'] = 'Loading Currently Synced Config';
			$this->CONFIG = $synced;
		}		

	}

	private function _prepVariables(){
		
		$this->OUTPUT['DEBUG_MODE'] = $this->DEBUG ? "DEBUG:ENABLED" : 'DEBUG:DISABLED';			
		$this->OUTPUT['EXECUTE'] = $this->EXECUTE ? "EXECUTE:ENABLED" : 'EXECUTE:DISABLED';	
		

		if($this->CONFIG === false){
			Output::jsonMessage(false,'Unable Parse or Locate Config file. Exit Code 002');	
		}

		$SERVER_ADDR_DETECT = $this->detectServerAddr();

		$this->ADDRESS_DNSFILTER 	= 'http://'.$SERVER_ADDR_DETECT.DNSFILTER_URL;
		$this->ADDRESS_ACFW 		= 'http://'.$SERVER_ADDR_DETECT.ACFW_URL;
		$this->ADDRESS_NETWORK		= 'http://'.$SERVER_ADDR_DETECT.NETWORK_URL;
		$this->ADDRESS_ALLOWIP		= 'http://'.$SERVER_ADDR_DETECT.ALLOWIP_URL;

		$this->CONFIG_CLEAN['DOMAIN_FILTERING'] 	= $this->_checkConfigItemExists('crwdomfltr','B');
		$this->CONFIG_CLEAN['FIREWALL_SETTINGS'] 	= $this->_checkConfigItemExists('crwfwswitch','B');
		//Biz firewall
		$this->CONFIG_CLEAN['cleanBizFW'] 			= $this->_checkConfigItemExists('bizfw',''); 
		//biz port forward
		$this->CONFIG_CLEAN['cleanBizPFWD'] 		= $this->_checkConfigItemExists('bizpfwd',''); 
		//crew port forwarding
		$this->CONFIG_CLEAN['cleanCrwPFW']			= $this->_checkConfigItemExists('crwpfwd','');
		//crew blocked/allowed ip
		$this->CONFIG_CLEAN['cleanCrwIPS']			= $this->_checkConfigItemExists('crwips','');
		//crew im,apps, or browinsg
		$this->CONFIG_CLEAN['cleanCrwAppFW']   		= $this->_checkConfigItemExists('crwappfw',''); 
		//crew blocked/alowed ports
		$this->CONFIG_CLEAN['cleanCrwPORTS']  		= $this->_checkConfigItemExists('crwports',''); 
		//crew blocked allowed domains
		$this->CONFIG_CLEAN['cleanDOM'] 			= $this->_checkConfigItemExists('crwdomains',''); 
		//crew captive portal bypass settings
		$this->CONFIG_CLEAN['cleanCPB'] 			= $this->_checkConfigItemExists('crwcpb',''); 
		//domains to block IS
		$this->CONFIG_CLEAN['cleanBLOCKOS']			= $this->_checkConfigItemExists('crwblockos','');
		//Default FW Rules to apply
		$this->CONFIG_CLEAN['cleanDefFWSett']		= $this->_checkConfigItemExists('crewdeffw','');

		$this->CONFIG_CLEAN['end']					= $this->_checkConfigItemExists('end','');
		$this->CONFIG_CLEAN['start']				= $this->_checkConfigItemExists('start','');
		$BLOCK_OS_IS_ENABLED						= $this->_checkConfigItemExists('BOS','1');
		$FW_PROTOCOL_SELECTED						= $this->_checkConfigItemExists('prot','PORT');
		//Wan Settings 
		$this->CONFIG_CLEAN['cleanWanSett']			= $this->_checkConfigItemExists('crwwansett','DHCP;');
		$this->CONFIG_CLEAN['cleanDnsSett']			= $this->_checkConfigItemExists('crwwandns','8.8.8.8;8.8.4.4');

		$this->BLOCK_OS_IS_ENABLED 	= intval($BLOCK_OS_IS_ENABLED) === 1 ? true : false;
		$this->FW_PROTOCOL_SELECTED = strtoupper($FW_PROTOCOL_SELECTED);
		/*
			IF Continue process is true Config is available
		*/
		$this->CONTINUE_PROCESS = true;
	}

	private function _cleanDataArray($data,$d1 = ';',$d2 = ';')
	{
		return implode( $d1, array_filter( explode( $d2 , $data ) ) );		
	}

	private function _checkConfigItemExists($key,$default = '',$dataList = false)
	{
		$dataList = $dataList === false ? $this->CONFIG : $dataList;
		if(isset($dataList[$key])){
			return $dataList[$key];
		}else{
			return $default;
		}
	}

	private function array_concat_values($array,$delimiter = ';')
	{
		$compiled = array();

		foreach($array as $ak => $v ){			
		if(strlen($v) >= 1){
				$compiled[] = $v;
			}			
		}

		return count($compiled) >= 1 ? implode(';',$compiled) : '';
	}

	public function set_ipset(){
		
		$compiledIPSet = $this->CONFIG_CLEAN['cleanCrwAppFW'];

		if($this->FW_PROTOCOL_SELECTED == "IPSET")
		{
			$this->OUTPUT['SET_IPSETRULES'] = "IPSET Function Called";

			$IP_SET_PARAMS = array_filter(explode(';',$compiledIPSet));					
			if(count($IP_SET_PARAMS) >= 1)
			{
				include_once IPSET_PATH;
				preg_match_all("/\[([^\]]*)\]/", $compiledIPSet, $matches);				
				$newCommand = $compiledIPSet;
				$adv_command = array();
				if(count(array_filter($matches)) >= 1)
				{
					foreach($matches[0] as $k => $rawWithBrackets){
						$newCommand = str_replace($rawWithBrackets,'',$newCommand);
						$adv_command[] = $matches[1][$k];
					}
										
					$final_adv_command = implode(';',$adv_command);
					$newCommand = implode(';',array_filter(explode(';',$newCommand)));
					
					$this->OUTPUT['SET_IPSETRULES_PARAMS_2'][] = "proc_adv_firewall($final_adv_command;)";	
					$this->OUTPUT['SET_IPSETRULES_PARAMS_1'][] = "ipset_parse($newCommand;)";	
					
					proc_adv_firewall("$final_adv_command",0,1);//append to the last rule		
					ipset_parse($newCommand.";");
				}else{
					$this->OUTPUT['SET_IPSETRULES_PARAMS'][] = "ipset_parse($compiledIPSet;)";				
					ipset_parse($compiledIPSet.";");
				}

				// foreach($IP_SET_PARAMS as $IPSET_KEY => $IPSET_VALUE)
				// {
				// 	$this->OUTPUT['SET_IPSETRULES_PARAMS'][] = "ipset_parse($IPSET_VALUE)";				
				// 	ipset_parse($IPSET_VALUE);		
				// }							
			}
		}else{
			$this->OUTPUT['SET_IPSETRULES'] = "Cannot Apply Empty IPSET Rules";
		}
	}

	public function set_end(){

		$compiledFW = $this->CONFIG_CLEAN['end'];
		
		if(strlen($compiledFW) >= 1)
		{
			$this->OUTPUT['SET_FIREWALL_END'] 	= "proc_adv_firewall($compiledFW,0,1) [APPEND]";
			proc_adv_firewall("$compiledFW",0,1);//append to the last rule		
		}
	}

	public function set_firewall()
	{
		//firewall Compile

		if($this->FW_PROTOCOL_SELECTED == "IPSET")
		{
			$compiledFW = $this-> array_concat_values(array(
				$this->CONFIG_CLEAN['start'],
				$this->CONFIG_CLEAN['cleanDefFWSett'],
				$this->CONFIG_CLEAN['cleanBizFW'],
				$this->CONFIG_CLEAN['cleanCrwIPS'],
				$this->CONFIG_CLEAN['cleanCrwPORTS'],
			));
		}else{
			$compiledFW = $this-> array_concat_values(array(
				$this->CONFIG_CLEAN['start'],
				$this->CONFIG_CLEAN['cleanDefFWSett'],
				$this->CONFIG_CLEAN['cleanBizFW'],
				$this->CONFIG_CLEAN['cleanCrwIPS'],
				$this->CONFIG_CLEAN['cleanCrwPORTS'],
				$this->CONFIG_CLEAN['cleanCrwAppFW'],				
			));
		}

		//portforward compile
		$compiledPF = $this-> array_concat_values(array(
			$this->CONFIG_CLEAN['cleanBizPFWD'],
			$this->CONFIG_CLEAN['cleanCrwPFW']
		));

		if($this->EXECUTE)
		{
			if($this->ACFW_USEURL)
			{
				file_get_contents($this->ADDRESS_ACFW.'?rules='.$compiledFW);
				file_get_contents($this->ADDRESS_ACFW.'?forward='.$compiledPF);	
				$this->OUTPUT['SET_FIREWALL'] 		= $this->ADDRESS_ACFW."?rules=".$compiledFW;	
				$this->OUTPUT['SET_PORTFORWARD'] 	= $this->ADDRESS_ACFW."?forward=".$compiledPF;		
				
				$this->APICALL_RESULT_MSG[] = 'Firewall Was Called';
				$this->APICALL_RESULT_MSG[] = 'Portforwarding Was Called';
			}else
			{
				include_once ACFW_PATH;			

				if(strlen($compiledFW) >= 1)
				{
					$this->OUTPUT['SET_FIREWALL'] 		= "proc_adv_firewall($compiledFW,0)";
					proc_adv_firewall("$compiledFW",0);
					$fwMessage = 'Changes to Firewall was saved';
				}else{
					$this->OUTPUT['SET_FIREWALL'] 	= "Firewall was not executed due to no data passed";
					$fwMessage = 'No changes to Firewall settings';
				}
				

				if(strlen($compiledPF) >= 1){
					$this->OUTPUT['SET_PORTFORWARD'] 	= "proc_adv_forwarding($compiledPF,0)";
					proc_adv_forwarding("$compiledPF",0);	
					$pfMessage = 'Changes Portforwarding Was Saved';
				}else{
					$this->OUTPUT['SET_PORTFORWARD'] 	= "Portforwarding Was Not Executed, No Data Given";
					$pfMessage = 'No changes to Portforwarding settings';
				}

				$this->APICALL_RESULT_MSG[] = $fwMessage;
				$this->APICALL_RESULT_MSG[] = $pfMessage;
			}
		}		
	}


	public function set_dnsfilter()
	{
		if($this->CONTINUE_PROCESS === false){return '';}
		$this->DOMAIN_FILTERING = strtoupper($this->CONFIG_CLEAN['DOMAIN_FILTERING']);
		$this->_dns_setblocking();		
		$this->_setDomains();
	}

	public function set_blocked_domains($synced_block_os_hash,$current_block_os_hash,$current_settings)
	{
		if($this->CONTINUE_PROCESS === false){
			return '';
		}	

		$DOMAINS 		= file_get_contents(BLOCKED_DOMAINS);
		$DOMAINS_ARRAY 	= json_decode($DOMAINS,true);
		$DOMAINS_PARSED = explode(';',$DOMAINS_ARRAY['crwblockos']);		

		if($this->DOMAIN_FILTERING == 'A' && $this->BLOCK_OS_IS_ENABLED)
		{
			$this->_addDomains($DOMAINS_PARSED);
			$this->OUTPUT['message'][] = "Added Block OS Domains";
		}else{
			if($current_settings['CURRENT_APPLIED_BLOCK_OS'] !== "")
			{
				$this->OUTPUT['PROCESS_TRAIL'][] = 'set_blocked_domains(disable)';
				$this->_removeDomains($DOMAINS_PARSED,'B');
				$this->_removeDomains($DOMAINS_PARSED,'A');
			}				
		}
	}

	public function _cleanDomainsonDNSdatabase()
	{
		if(self::ConfigHasChanges())
		{
			if(DNSFILTER_USEURL)
			{
				if($this->DEBUG){
					$this->OUTPUT[__FUNCTION__][] = $this->ADDRESS_DNSFILTER.'read_dnsfilter';
				}
				$data = file_get_contents($this->ADDRESS_DNSFILTER.'read_dnsfilter');		
			}else{							
				if($this->DEBUG){
					$this->OUTPUT[__FUNCTION__][] = "read_dnsfilter()";
				}
				$data = read_dnsfilter();
			}

			$result = preg_split('/\s+/', $data);
			
			if(count($result) >= 1)
			{
				$this->APICALL_RESULT_MSG[] = "Clean Up Domains";
				$currentBlockingScheme = $result[0];
				unset($result[0]);			
				$this->_removeDomains(array_filter($result),$currentBlockingScheme);		
			}			
		}else{
			$this->APICALL_RESULT_MSG[] = "No Changes To DOMAIN";
		}


	}

	private function _removeDomains($data,$IOP = false)
	{
		$OP = $IOP === false ? $this->DOMAIN_FILTERING : $IOP;
		if(is_array($data) && count($data) >=1)
		{
			foreach($data as $k => $domains_to_process)
			{
				$search = 'USRINPT-';
				$domains_to_process = strpos($search,trim($domains_to_process)) >= 0 ? str_replace($search,'',$domains_to_process) : $domains_to_process;
				if($OP == 'B')
				{
					$param = "?blacklist_remove={$domains_to_process}";
					$param_func = "B";					
				}else{
					$param = "?whitelist_remove={$domains_to_process}";
					$param_func = 'W';
				}

				if(strlen($domains_to_process) >= 2)
				{
					if(DNSFILTER_USEURL)
					{
						if($this->DEBUG){
							$this->OUTPUT['_removeDomains'][] = $this->ADDRESS_DNSFILTER.$param;
						}
						file_get_contents($this->ADDRESS_DNSFILTER.$param);		
					}else{							
						if($this->DEBUG){
							$this->OUTPUT['_removeDomains'][] = "remove_bwlist($param_func,$domains_to_process)";
						}
						remove_bwlist($param_func,$domains_to_process);
					}
				}				
			}					
		}

		return $this;
	}

	private function _addDomains($data,$IOP = false)
	{
		$OP = $IOP === false ? $this->DOMAIN_FILTERING : $IOP;
		if(is_array($data) && count($data) >=1)
		{
			foreach($data as $k => $domains_to_process)
			{
				$search = 'USRINPT-';
				$domains_to_process = strpos($search,trim($domains_to_process)) >= 0 ? str_replace($search,'',$domains_to_process) : $domains_to_process;				
				if($OP == 'B')
				{
					$param = "?whitelist_allow={$domains_to_process}";
					$param_func = "W";					
				}else{
					$param = "?blacklist_allow={$domains_to_process}";					
					$param_func = 'B';					
				}

				if(strlen($domains_to_process) >= 2){					

					if($this->EXECUTE)
					{
						if(DNSFILTER_USEURL)
						{
							if($this->DEBUG){
								$this->OUTPUT['_addDomains'][] = $this->ADDRESS_DNSFILTER.$param;
							}
							file_get_contents($this->ADDRESS_DNSFILTER.$param);		
						}else{							
							if($this->DEBUG){
								$this->OUTPUT['_addDomains'][] = "add_bwlist($param_func,$domains_to_process)";
							}
							add_bwlist($param_func,$domains_to_process);
						}										
					}					
				}
			}
		}

		return $this;
	}


	private function _setDomains()
	{
		$WList 	= $this->_dns_getWlist();
		$BList 	= $this->_dns_getBlist();

		if($this->DEBUG)
		{
			$this->OUTPUT['WhiteList'] = $WList;			
			$this->OUTPUT['BlackList'] = $BList;					
		}

		$NewDom	= explode(';',$this->CONFIG_CLEAN['cleanDOM']);
		//clear all whitelist and blacllist from config
		// $this->_cleanDomainsonDNSdatabase();
		$this->_removeDomains($BList,"B");	
		$this->_removeDomains($WList,"A");
		$this->_addDomains($NewDom);
		$this->APICALL_RESULT_MSG[] = 'Updated Domains Whitelist/Blacklist';
	}

	private function _dns_setblocking()
	{
		
		$DATA = $this->DOMAIN_FILTERING;
		$result = '';
			
		if($this->EXECUTE)
		{

			if(DNSFILTER_USEURL)
			{
				if($this->DEBUG){
					$this->OUTPUT['DNS_BLOCKING'] = $this->ADDRESS_DNSFILTER.'?setallowblock='.$DATA;
				}
				$result = file_get_contents($this->ADDRESS_DNSFILTER.'?setallowblock='.$DATA);
				$this->APICALL_RESULT_MSG[] = 'DNS set to '.$DATA;			
			}else{
				if($this->DEBUG){
					$this->OUTPUT['DNS_BLOCKING'] = "set_dnsfilter($DATA)";
				}
				set_dnsfilter($DATA);
			}
			
		}

		return $result;
	}

	private function _dns_getWlist()
	{
		if(DNSFILTER_USEURL){
			$DOMAINS = strip_tags(file_get_contents($this->ADDRESS_DNSFILTER."?whitelist_read"));
		}else{
			$DOMAINS = read_bwlist('W');	
		}	
		return array_filter(explode('|',str_replace("\n",'|',trim($DOMAINS))));
	}

	private function _dns_getBlist()
	{			
		if(DNSFILTER_USEURL){
			$DOMAINS = strip_tags(file_get_contents($this->ADDRESS_DNSFILTER."?blacklist_read"));
		}else{
			$DOMAINS = read_bwlist('B');	
		}	
		return array_filter(explode('|',str_replace("\n",'|',trim($DOMAINS))));
	}

	public function set_wan()
	{

		if($this->CONTINUE_PROCESS === false)
		{
			return '';
		}
		
		$DNS_SETTINGS = array_filter(explode(';',$this->CONFIG_CLEAN['cleanDnsSett']));
		$WAN_SETTINGS = array_filter(explode(';',$this->CONFIG_CLEAN['cleanWanSett']));				

		$build['setwan'] = 'setwan';


		$protocol = '';
		$IPADDRESS = '';
		$netmask = '';


		if(count($WAN_SETTINGS) >= 4)
		{
			$build['proto']	 	 = 'static';
			$build['ipaddr']	 = $WAN_SETTINGS[1];
			$build['netmask']	 = $WAN_SETTINGS[2];
			$build['gateway']	 = $WAN_SETTINGS[3];
			$build['broadcast']	 = $WAN_SETTINGS[4];
			$build['dns']	 	 = isset($DNS_SETTINGS[0]) ? $DNS_SETTINGS[0] : '8.8.8.8';
		}else{			
			$build['proto']	 = 'dhcp';
		}


		if(NETWORK_USEURL)
		{
			$PARAMS = http_build_query($build);
			$WAN_SET_URL = $this->ADDRESS_NETWORK.'?'.$PARAMS;
			if($this->DEBUG){
				$this->OUTPUT['PORT_FORWARDING'] =  $WAN_SET_URL;				
			}

			if($this->EXECUTE){
				//file_get_contents( $WAN_SET_URL );	
			}
			
			$this->APICALL_RESULT_MSG[] = 'WAN set to '.$PARAMS;
		}else{			

			if($build['proto']	== 'dhcp'){
				$this->APICALL_RESULT_MSG[] = 'WAN set to DHCP';
				set_wan('dhcp');	
			}else{
				$this->APICALL_RESULT_MSG[] = 'WAN set to STATIC '.$this->CONFIG_CLEAN['cleanWanSett'];
				set_wan($build['proto'], $build['ipaddr'], $build['netmask'], $build['gateway'], $build['broadcast'], $build['dns'] );
			}
		}
	}

	public function set_captivePortal()
	{
		if($this->CONTINUE_PROCESS === false)
		{
			return '';
		}

		$param = $this->CONFIG_CLEAN['cleanCPB'];		

		if(strlen($param) >= 1){

			$test = array_filter(explode(';',$param));

			$parsedIPs = array();
			$parsedAlias = array();

			if(count($test) >= 1)
			{				
				foreach($test as $val)
				{
					$parsedIPs[] = strpos($val, 'DEF-') !== FALSE ? substr($val,strlen('DEF-')) : $val;
					$parsedAlias[] = strpos($val, 'DEF-') !== FALSE ? 'DEF' : 'IPDOM';
				}

				$parameters = implode(';',$parsedIPs);
				$aliases = implode(';',$parsedAlias);
			}else{
				$parameters = $param;
				$aliases = 'IPDOM';
			}			



			$URL = $this->ADDRESS_ALLOWIP."?set=".$parameters.';|'.$aliases.';';
			if($this->DEBUG){
				$this->OUTPUT['captivePortal'] =  $URL;
			}

			if($this->EXECUTE){
				file_get_contents($URL);	
			}

			$this->APICALL_RESULT_MSG[] = 'Captive Portal Updated';
		}
		
	}

	public function applyCurrentSettings()
	{
		$rebootNow = false;
		if($this->CONTINUE_PROCESS)
		{			
			if(self::ConfigHasChanges())
			{
				$current_settings = file_exists(CURRENT_APPLIED_CONFIG)  ? json_decode(file_get_contents(CURRENT_APPLIED_CONFIG),true) : array();
				$this->OUTPUT['PROCESS_TRAIL'][] = 'set_firewall Initialized';
				$this->set_firewall();

				$this->OUTPUT['PROCESS_TRAIL'][] = 'set_wan Initialized';
				$this->set_wan();

				$this->OUTPUT['PROCESS_TRAIL'][] = 'set_captivePortal Initialized';
				$this->set_captivePortal();

				$this->OUTPUT['PROCESS_TRAIL'][] = 'set_dnsfilter Initialized';
				$this->set_dnsfilter();

				$this->OUTPUT['PROCESS_TRAIL'][] = 'set_blocked_domains Initialized';
				$this->set_blocked_domains($synced_firewall_hash,$synced_block_os_hash,$current_settings);
				
				$this->OUTPUT['PROCESS_TRAIL'][] = 'set_ipset Initialized';
				$this->set_ipset();

				$this->OUTPUT['PROCESS_TRAIL'][] = 'set_end Initialized';
				$this->set_end();


	 	
	 			$CREATE_HTML_OUTPUT = new HTML_CREATE;
	 			$CREATE_HTML_OUTPUT->get_config();
	 			$RAW_IP_ADDRESS = $this->_checkConfigItemExists('crwips','');
	 			$RAW_PORTS 		= $this->_checkConfigItemExists('rawport','');
				$this->OUTPUT['message'][] = $CREATE_HTML_OUTPUT->firewall($RAW_IP_ADDRESS,$RAW_PORTS,$this->CONFIG_CLEAN['FIREWALL_SETTINGS']);
				$this->OUTPUT['message'][] = $CREATE_HTML_OUTPUT->apps(file_get_contents(IMAPPS_INI),$this->CONFIG_CLEAN['FIREWALL_SETTINGS']);
				$this->OUTPUT['message'][] = $CREATE_HTML_OUTPUT->domainfilter($this->CONFIG_CLEAN['cleanDOM'],$this->CONFIG_CLEAN['DOMAIN_FILTERING'],$this->BLOCK_OS_IS_ENABLED);
				$this->OUTPUT['message'][] = $CREATE_HTML_OUTPUT->CaptivePortalBypass($this->CONFIG_CLEAN['cleanCPB']);
				$this->OUTPUT['PROCESS_TRAIL'][] = 'buildLockFile';
				$CREATE_HTML_OUTPUT->buildLockFile();

				
				$this->apply_config();
				$this->OUTPUT['message'][] = 'Router Will Reboot';
				$this->APICALL_RESULT_MSG[] = "Router Will Reboot";
				$rebootNow = true;
			}else{
				$this->APICALL_RESULT_MSG[] = "No Changes To Firewall Settings";				
			}
		}else{
			$this->OUTPUT['message'][] = 'Error in applying current settings. Exit code 003';
		}
		$this->OUTPUT['PROCESS_TRAIL'][] = 'REBOOT ROUTER?: '.$rebootNow === true ? 'YES!' : 'NO!';
		$this->logProcessTransaction();

		if($rebootNow){
			$this->RebootRouter();	
		}
		
	}

	public function apply_config()
	{
		$this->OUTPUT['PROCESS_TRAIL'][] = 'apply_config';
		$CurrentBLockOSConfig = @json_decode(@file_get_contents(BLOCKED_DOMAINS),true);
		$build_log = array();
		$build_log['CURRENT_APPLIED_HASH'] 				= $this->_checkConfigItemExists('hash','');


		$hashBlockOS = $this->_checkConfigItemExists('hash_blckos',false);
		$BOS_ENABLED = $this->_checkConfigItemExists('BOS',1);
		if($BOS_ENABLED == 1)
		{
			if($hash_blckos){
				$build_log['CURRENT_APPLIED_BLOCK_OS'] 			= $hashBlockOS;
			}else{
				$build_log['CURRENT_APPLIED_BLOCK_OS'] 			= $CurrentBLockOSConfig['hash_blckos'];
			}
		}else{
			$build_log['CURRENT_APPLIED_BLOCK_OS'] 			= '';
		}
		
		$build_log['HASH_SYNCED_ON_ROUTER_TIME'] 		= $this->_checkConfigItemExists('router_time_updated','');
		$build_log['HASH_APPLIED_ON_ROUTER_TIME'] 		= date('Y-m-d H:i:s e | c');
		@file_put_contents(CURRENT_APPLIED_CONFIG,json_encode($build_log));

		$copy_synced_config = file_get_contents(SYNCAPPLY_INI);
		file_put_contents(APPLIED_RULES, $copy_synced_config);		
	}

	public function output(){
		$this->OUTPUT['message'] = $this->APICALL_RESULT_MSG;
		return $this->OUTPUT;
	}

	public function config(){
		$this->OUTPUT['CONFIG'] = $this->CONFIG_CLEAN;				
	}
	public function logProcessTransaction(){

		$write['config'] = $this->CONFIG_CLEAN;
		$write['output'] = $this->OUTPUT;
		file_put_contents( APPLYRULES_LOG , json_encode($write,JSON_PRETTY_PRINT) );
	}

	public function detectServerAddr(){
		
		if(isset($_SERVER['SERVER_ADDR'])){
			return $_SERVER['SERVER_ADDR'];
		}else{
			//error when command line no $_SERVER vars
			//check lastknow ip file
			return file_exists(LAST_KNOWN_SERVER_ADDR) ? trim(file_get_contents(LAST_KNOWN_SERVER_ADDR)) : '127.0.0.1';			
		}
	}

	public function tagLastKnowServerAddr()
	{
		if(isset($_SERVER['SERVER_ADDR']))
		{
			file_put_contents(LAST_KNOWN_SERVER_ADDR,trim($_SERVER['SERVER_ADDR']));
		}
	}

	public function RebootRouter(){
		if(REBOOT_ON_SUCCESSFULL_SYNC)
		{
			$lastRouterRebootMessage = date(DATE_RFC850);
			file_put_contents(LAST_REBOOT,$lastRouterRebootMessage);		
			sleep(5);
			exec('reboot');	
		}
		return $this;
	}

	static function ConfigHasChanges()
	{
		$synced 	= @json_decode(@file_get_contents( SYNCAPPLY_INI ),true);
		$applied 	= @json_decode(@file_get_contents( APPLIED_RULES ),true);

		if($synced['hash'] == $applied['hash'])
		{
			if(isset($synced['BOS']) && $synced['BOS'] == $applied['BOS'])
			{
				return false;
			}else{
				return true;				
			}
		}else{
			return true;
		}
	}
}