<?php
	include 'config.php';

	$file_hashes = array();
	if(file_exists('/www/cgi-bin/firewall/config.php')){
		$file_hashes['ConfigFile'] = md5_file('/www/cgi-bin/firewall/config.php');
	}
	if(file_exists('/www/cgi-bin/firewall/requestrules.php')){
		$file_hashes['requestrules'] = md5_file('/www/cgi-bin/firewall/requestrules.php');
	}

	if(file_exists('/www/cgi-bin/firewall/applyrules.php')){
		$file_hashes['applyrules'] = md5_file('/www/cgi-bin/firewall/applyrules.php');
	}

	if(file_exists('/www/cgi-bin/firewall/process.php')){
		$file_hashes['process'] = md5_file('/www/cgi-bin/firewall/process.php');
	}

	function buildURL($PAGE = ''){
		$PROTOCOL = 'HTTP';
		if(isset($_SERVER['SERVER_PROTOCOL']) && strpos('HTTP',strtoupper($_SERVER['SERVER_PROTOCOL']) ) >= 0 ){
		  $PROTOCOL = 'HTTP';
		}else if(isset($_SERVER['SERVER_PROTOCOL']) && strpos('HTTPS',strtoupper($_SERVER['SERVER_PROTOCOL']) ) >= 0 ){
		  $PROTOCOL = 'HTTPS';
		}

		$DOMAIN = isset($_SERVER['SERVER_ADDR']) ? $_SERVER['SERVER_ADDR'] : $_SERVER['SERVER_NAME'];
		$PATH_SEARCH   = pathinfo($_SERVER['PHP_SELF']);
		$PATH = isset($PATH_SEARCH['dirname']) ? $PATH_SEARCH['dirname'].'/' : CURRENT_URL;

		return $PROTOCOL.'://'.$DOMAIN.$PATH.$PAGE;
	}
  
?>
<!DOCTYPE html>
<html lang="en">
<head>
<title>CrewCommCenter Vessel System Management</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<style>
  body,html,*{
      font-family:Verdana, Geneva, sans-serif;
      padding:0;
      margin:0;
      font-size:12px;
  }

  body
  {
    font-family:Verdana, Geneva, sans-serif;  
    color: black;
    position: relative;
    background: #e3e3e3;
    -webkit-background-size: cover;
    -moz-background-size: cover;
    -o-background-size: cover;
    background-size: cover;
  }

  #shipconfig{
    border-radius:10px;
    background-color: #e3e3e3;
    box-shadow: 5px 5px 1px #346585;
    margin: 10px auto ;
    width: 90%;
    max-width: 90%;
    min-width: 90%;
  }

  .clearfix{
    clear:both;
    overflow: auto;
  }

  .left-part{
    width :100%;
    float:left;
    display:inline-block;
    position: static;
  }

  .right-part{
    width:100%;
    float:right;
    display:block;
    position: static;
  }

  input[type=text],input[type=password] { 
    font-family:Verdana, Geneva, sans-serif;
    font-size:14px;
    color: black;
    width: 80%;
  }

  .cp-main{
    width:90%;
    display: block;
    background: #e3e3e3;
    margin: 20px auto 0 auto;
    position: relative;
    border: 1px solid #464B4F;
  }

  .cp-head{
    background:#464b4f;
    color:#FFF;
    padding:5px 10px;
    font-size: 14px;
    font-weight: bold;
    text-align: center;
    min-height: 22px;
  }
  .cp-body{
    position: relative;
    padding:10px;
  }

  .cp-body.cp-body-tabled{
    min-height: 100px;
    position: relative;
    max-height: 260px;
    overflow: hidden;
    overflow-y: hidden;
    overflow-y: auto;
  }


  .cp.col{
    display: block;
  }
  .cp-row{
    padding:1px 4px;
    display: inline-block;
  }
  .cp-inline > label,
  .cp-inline > input{
    display: block;
  }

  .select-widths{
    width:100%;
  }
  .input-widths{
    width:100%;
  }

  #inputResultsPage{
    padding:25px;
  }

  #inputResultsPage input{
    width:75%;
    margin:2px 0;
  }

  .im-display{
  list-style: none;
  }
 
 .im-display li{
  padding:4px 5px;
  margin-left:10px;
  }

  .show-menu{
    padding:5px;
  }
  .input-width{
    width: 700px;
  }

  .display-table{
    border:none;
    width: 100%;
    border-collapse:collapse;
  }

  .display-table tbody tr:hover td,
  .display-table tbody tr:hover td a{
    background:#464B4F;
    color:#E0EEEE;
  }
  .display-table tbody tr:nth-child(odd){
    background: #E0EEEE;
  }
  .display-table tbody tr:nth-child(even){
    background: #FFFFFF;

  }
  .display-table thead tr td{
    font-weight: bold;
  }

  .display-table tbody tr td,
  .display-table thead tr td{
    padding: 3px 6px;
  }
  .btn-link{
      background: none;
      border: none;
      color: #126ab7;
  }
  .resultsPage{
    padding:0 8px;
  }
  p > small{
    font-size: 10px;
      color: #847272;
      display: block;
  }
</style>
</head>
  <body>  
  <div id="cp-modal" class="cp-modal" style="width:100%;background:rgba(0,0,0,0.2);height:100vh;position: absolute;z-index: 9999;display:none;top:-20px;">    
    <div class="cp-modal-body" style="position:relative;margin:20% auto 0 auto;display: block;width: 30%;text-align: center;background: #FFF;padding:11px;border: 1px solid blueviolet;">
      <div class="cp-modal-text" style="margin: 10px 7px;"></div>
      <button id="cp-modal-hide-btn" type="button" onClick="(function(){modal('hide'); return false;})()" style="display:none;margin:0 auto">Close</button>      
    </div>
  </div>
  <div class="cp-main">
    <div class="cp-head">
      ADMINISTRATIVE SYNCHRONIZATION DASHBOARD for FW Version 2 <sup>Beta 0.1</sup>
    </div>
    <div class="cp-body">
      <input type="hidden" name="proces_url" id="process_url" value="<?php echo buildURL('process.php');?>">
      <input type="hidden" name="applyFWrules" id="applyFWrules" value="<?php echo buildURL('process.php?RUNFIREWALL');?>">
      <div id="sync_output">

      </div>
      <div id="curr_sett-container" style="border:1px solid #CCC;padding:0 5px 5px 5px">
        <p><strong>Current Settings:</strong></p>
        <div id="curr_sett"></div>
      </div>        

      
      
      <div style="display:inline-block;width: 300px">
        <button id="loadCurrentSettings" type="buttton" style="display:block;width:100%">VIEW CURRENT SETTINGS</button>        
        <a  href="<?php echo CURRENT_URL.'/showlogs.php';?>" style="display:block;width:100%" target="_blank">Show Logs</a>  
      </div>
      <div style="display:inline-block;float:right;width: 300px">
        <button type="button" id="apply_sync_data" style="display:block;width:100%" class="apply_sync_data">APPLY SETTINGS TO ROUTER</button>
        <button id="syncSettings" type="buttton" style="width: 100%">SYNCHRONISE FIREWALL SETTINGS</button>
        <button id="syncSettingsForced" type="buttton" style="width: 100%">FORCE SYNCHRONISE FIREWALL SETTINGS</button>  
      </div>      
    </div>
    <br><br><br>
    <div class="clearfix"></div>
    <hr>    
    <br>
    <div>
      <br>
      <div>      
        <?php        
          $current_applied = @json_decode(@file_get_contents(CURRENT_APPLIED_CONFIG),true);
          $current_sync    = @json_decode(@file_get_contents(SYNCAPPLY_INI),true);
          $currentSynced = isset($current_sync['hash_blckos']) ? $current_sync['hash_blckos'] : '';
          $style1 = $current_applied['CURRENT_APPLIED_HASH'] !== $current_sync['hash'] ? 'color:#F00' : 'color:#48BB22';
          $style2 = $current_applied['CURRENT_APPLIED_BLOCK_OS'] !== $currentSynced && $currentSynced !== '' ? 'color:#F00' : 'color:#48BB22';
        ?>        
        <p>Current Settings Applied:&nbsp;<span style="font-weight:bold;<?php echo $style1;?>"><?php echo $current_applied['CURRENT_APPLIED_HASH'];?></span></p> 
        <?php if(isset($current_applied['CURRENT_APPLIED_BLOCK_OS'])):?>       
          <p>Current BLOCK DOMAIN Applied:&nbsp;<span style="font-weight:bold;<?php echo $style2;?>"><?php echo @$current_applied['CURRENT_APPLIED_BLOCK_OS'] == '' ? 'Block OS Updates is Disabled' : @$current_applied['CURRENT_APPLIED_BLOCK_OS'];;?></span></p>        
        <?php else:?>
          <p>Current BLOCK DOMAIN Applied: NO DATA</p>
        <?php endif;?>
        <p>Current Settings Was Synced ON:&nbsp;<?php echo $current_applied['HASH_SYNCED_ON_ROUTER_TIME'];?>(Router Time)</p>        
        <p>Current Settings Was Applied ON:&nbsp;<?php echo $current_applied['HASH_APPLIED_ON_ROUTER_TIME'];?>(Router Time)</p>                
        <br>
        <hr>
        <br>
        <p>Last Config Synced:&nbsp;<?php echo $current_sync['router_time_updated'];?>(Router Time)</p>        
        <p>Last Config Settings Hash:&nbsp;<span style="font-weight:bold;<?php echo $style1?>"><?php echo $current_sync['hash'];?></span></p>
        <p>Last Config BLOCK DOMAIN Hash:&nbsp;<span style="font-weight:bold;<?php echo $style2?>"><?php echo $currentSynced == '' ? '** No New Settings **' : $currentSynced;?></span></p>
		<hr>
		<p>File CheckSums:</p>
		<?php if(count($file_hashes) >= 1):?>        
			<?php foreach($file_hashes as $FileName => $FileHash):?>
				<p><?php echo "<strong>".$FileHash."</strong> - ".$FileName;?></p>
			<?php endforeach;?>
		<?php endif;?>
      </div>
      <br>
    </div>
  </div>
  </body>

  <script>
    (function(window,document){
          var applyData = document.getElementById('apply_sync_data');
          applyData.addEventListener('click',function(){


          var ConfirmApply = confirm('Do you wish to continue and apply synchronized Settings?');
          if(ConfirmApply){
            modal('show' , 'Processing, Please do not refresh browser');
            var URL     = document.getElementById('applyFWrules');   
            var request = new XMLHttpRequest();
            request.open('GET', URL.value , true);
            request.onload = function() {
              if (this.status >= 200 && this.status < 400) {
                // Success!

                  var RuntimeHasError = false;
                  try{
                    var resp = JSON.parse(this.response);
                    RuntimeHasError = true;
                  }catch(error){
                    console.error(error);
                  }
                
                  if(RuntimeHasError)
                  {
                    if(Array.isArray(resp.message)){
                      var _msg = "",_holdr = resp.message
                      for(var _x = 0 ; _x < _holdr.length ; _x++){
                        _msg += _holdr[_x]+"<br>";
                      }
                    }else{
                      _msg = resp.message;
                    }
                    
                    modal('show' , _msg , true);
                  }else{
                    modal('show','Process returned Unexpected. Error Code [R3]',true);  
                  }
              } else {
                // We reached our target server, but it returned an error
                modal('show','Error has been encountered code [R3410]',true);
              }
            };

            request.onerror = function() {
               modal('show','Error has been encountered code [R3411]',true);  
              // There was a connection error of some sort
            };

            request.send();         
          }    
      }); 

      function _checkUndefined(arg){
        if(typeof arg == undefined){
          return '';
        }else{
          return arg;
        }
      }

      function display_recieved_data(data){
        var config = 'Settings Synced from Web Support<br><br><br>';
        // config += '<br><br><button type="button" id="apply_sync_data" class="apply_sync_data">APPLY SETTINGS TO ROUTER</button><br><br>';

        config += "<h4>Crew Settings</h4><hr><br>";
        if(typeof data.dataSynced != "undefined")
        {
          
          var data                  = data.dataSynced;
          var blockOS               = _checkUndefined(data.BOS);
          var captivePortalBypass   = _checkUndefined(data.crwcpb);
          var domainfiltering       = _checkUndefined(data.crwdomfltr);
          var firewallFW            = _checkUndefined(data.crwfwswitch);
          var domainFilter          = _checkUndefined(data.crwdomains);
          var crewPortForward       = _checkUndefined(data.crwpfwd);
          var wan                   = _checkUndefined(data.crwwansett);
          
          if(captivePortalBypass == null)
          {
            config += 'No Domains Added on <strong>Captive Portal Bypass Settings</strong><br>';
          }else{
            var cpbDOMS = captivePortalBypass.split(';');
            config += "Domains for <strong>Captive Portal Bypass Settings</strong><br>";
            for(var cpbDOMSc = 0 ; cpbDOMSc < cpbDOMS.length ; cpbDOMSc++){
              config += "&nbsp;&nbsp;- "+cpbDOMS[cpbDOMSc]+"<br>";
            }
            config += '<br>';
          }
          
          if(domainfiltering == 'B')
          {
            var DOMFILSTAT1 = 'Block All, Allow:';
            var DOMFILSTAT2 = 'Allowed';
            config += 'Domain Filtering is set to <strong>Block ALL</strong><br>';
          }else{
            var DOMFILSTAT1 = 'Allow All, Block:';
            var DOMFILSTAT2 = 'Blocked';
            config += 'Domain Filtering is set to <strong>ALLOW ALL</strong><br>';

            if(blockOS == 0 || blockOS == '0')
            {
              config += 'BLOCK OS is <strong>Disabled</strong><br>';
            }else{
              config += 'BLOCK OS is <strong>Enabled</strong><br>';
            }            
          }                         
                    
          if(domainFilter == null || domainFilter == ''){
            config += "No Domains to <strong>"+DOMFILSTAT2+"</strong><br>";
          }else{
            config += DOMFILSTAT2+" domains<br>";
            var domainFilterSplit = domainFilter.split(';');

            for(var dx = 0 ; dx < domainFilterSplit.length ; dx++){
              config += "&nbsp;&nbsp;- "+domainFilterSplit[dx]+"<br>";
            }

            config += "<br>";           
          }


          if(firewallFW == 'B')
          {
            var FWFILSTAT1 = 'Close All , except:';
            var FWFILSTAT2 = 'Allowed';
            config += 'Firewall is set to <strong>Close ALL</strong><br>';
          }else{
            var FWFILSTAT1 = 'Open All except:';
            var FWFILSTAT2 = 'Blocked';
            config += 'Firewall is set to <strong>Open ALL</strong><br>';
          }

          if( typeof data.crwapps == "object" && Object.keys(data.crwapps).length >= 1)
          {
            var IMAPPS = data.crwapps;
            config += '<ul class="im-display">';
            config += "<li><strong>Allowed Apps:</strong></li>";
            for (var key in IMAPPS) {
              config += "<li>";
              config += "[X] "+IMAPPS[key].name+"<br>";

              if(typeof IMAPPS[key].label != "undefined"){
                var IM_Labels = IMAPPS[key].label;
                for(var _x = 0 ; _x < IM_Labels.length ; _x++){
                  config += "&nbsp;&nbsp;|-- "+IM_Labels[_x]+"<br>";
                }
              }

              config +="</li>";
              // console.log(key, IMAPPS[key]);
            }

            config += "</ul>";
            
          }else{
            if(firewallFW == 'B'){
              config += "No IM APPS or Browsing Selected <br>";  
            }           
          }

          config+= "<br>";
          if(data.crwips == null || data.crwips == '')
          {
            config += "No <strong>"+FWFILSTAT2+"</strong> IP's<br>";
          }else{
            var ipSplit = (data.crwips).split(';');
            config += FWFILSTAT2+" IP's: <br>";           
            for(var cipSplit = 0 ; cipSplit < ipSplit.length ; cipSplit++){
              config += "&nbsp; - "+ipSplit[cipSplit]+"<br>";
            }           
            config += "<br>";
          }

          if(data.crwports == null || data.crwports == '')
          {
            config += "No <strong>"+FWFILSTAT2+"</strong> PORTS<br>";
          }else{

            var PortSplit = (data.crwports).split(';');
            config += FWFILSTAT2+" PORTS: <br>";
            for(var cPortSplit = 0 ; cPortSplit < PortSplit.length ; cPortSplit++){
              config += "&nbsp; - "+PortSplit[cPortSplit]+"<br>";
            }           
            config += "<br>";       
          }


          if(crewPortForward == null || crewPortForward == ''){

          }else{
            var crewPortForwardSplit = crewPortForward.split(';');
            config += "Port Forward Settings found <br>";
            for(var cpfs_counter = 0; cpfs_counter < crewPortForwardSplit.length ; cpfs_counter++){
              // var currentPF = crewPortForwardSplit[cpfs_counter].split('|');
              // config += "&nbsp;&nbsp; <strong>Name:</strong>"+currentPF[0]+", <strong>Protocol:</strong> "+currentPF[1]+", <strong>Source Port:</strong> "+currentPF[2]+", <strong>Destination Port:</strong> "+currentPF[3]+", <strong>Destination IP:</strong> "+currentPF[4]+"<br>";
              config += "&nbsp;&nbsp;"+crewPortForwardSplit[cpfs_counter]+"<br>";
            }
          }


          if(wan){
            config += "<br>";
            var wanData = wan.split(';');
            var wanNoEmpty = wanData.filter(data => data !== '' || data.length >= 1);
            
            if(typeof wanNoEmpty[0] != "undefined"){
              config += "Wan Mode: <strong>"+wanNoEmpty[0]+"</strong><br>";

              if(wanNoEmpty[0].toUpperCase() == 'STATIC'){
                if(typeof wanNoEmpty[1] != "undefined"){
                  config += "&nbsp;&nbsp;- IP Address: "+wanNoEmpty[1]+"<br>";                  
                }
                if(typeof wanNoEmpty[2] != "undefined"){
                  config += "&nbsp;&nbsp;- Subnet Mask: "+wanNoEmpty[2]+"<br>";                  
                }
                if(typeof wanNoEmpty[3] != "undefined"){
                  config += "&nbsp;&nbsp;- Gateway Address: "+wanNoEmpty[3]+"<br>";
                }
                if(typeof wanNoEmpty[4] != "undefined"){
                  config += "&nbsp;&nbsp;- Broadcast Address: "+wanNoEmpty[4]+"<br>";
                }
              }
            }       
          }             

          config += "<br>";
          config += "<br>";
          config += "<br><h4>Business Settings</h4><hr>";
          config += "<br><br>";          
          document.getElementById("sync_output").innerHTML = config;
          
        }else{
          
        }
      }

      function syncSettings(forced){

        modal('show','Synchronizing settings please wait');

        var URL     = document.getElementById('process_url');    
        var request = new XMLHttpRequest();     

        var param   = "retrieveserversettings=1"
        if(forced === true){
           param   += "&forced=1"
        }
        

        request.open('POST', URL.value , true);
        request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');

        request.onload = function() {
          if (this.status >= 200 && this.status < 400) {
            // Success!

              var RuntimeHasError = false;
              var _msg = forced === true ? 'Forced Update Detected<br>' : '';
              try{
                var resp = JSON.parse(this.response);
                RuntimeHasError = true;
              }catch(error){
                console.error(error);
              }
            
              if(RuntimeHasError)
              {
                display_recieved_data(resp);
                console.log(resp);

                if(typeof resp.message != "undefined" && resp.message != null && (resp.message).length >= 1){
                  var _holdr = resp.message;

                  if(Array.isArray(resp.message)){
                    for(var _x = 0 ; _x < _holdr.length ; _x++){
                      _msg += _holdr[_x]+"<br>";
                    }
                  }else{
                    _msg = resp.message;
                  }
                  
                  modal('show' , _msg , true);
                }else{
                  modal('show','Error encoutered while processing request. Error Code [R1]',true);  
                }         
              }else{
                modal('show','Process returned Unexpected. Error Code [R2]',true);  
              }
          } else {
            // We reached our target server, but it returned an error
            modal('show','Error has been encountered code [R2410]',true);
          }
        };

        request.onerror = function() {
           modal('show','Error has been encountered code [R2411]',true);  
          // There was a connection error of some sort
        };

        request.send(param);
      }


      function display_fetched_settings(data){
        var template = "";
        template += data['firewall'];
        template += data['portforward'];
        template += data['dnsmasq'];
         document.getElementById("curr_sett").innerHTML = template;
      }

      function loadCurrentSettings()
      {

        modal('show','Fetching Current settings. Please wait');

        var URL     = document.getElementById('process_url');    
        var request = new XMLHttpRequest();                  
        var param   = "loadcurrentfwsettings=1"

        request.open('POST', URL.value , true);
        request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');

        request.onload = function() {
          if (this.status >= 200 && this.status < 400) {
            // Success!

              var RuntimeHasError = false;
              try{
                var resp = JSON.parse(this.response);
                RuntimeHasError = true;
              }catch(error){
                console.error(error);
              }
            
              if(RuntimeHasError)
              {
                display_fetched_settings(resp);


                if(typeof resp.message != "undefined" && resp.message != null && (resp.message).length >= 1){
                  var _msg = '',_holdr = resp.message;

                  if(Array.isArray(resp.message)){
                    for(var _x = 0 ; _x < _holdr.length ; _x++){
                      _msg += _holdr[_x]+"<br>";
                    }
                  }else{
                    _msg = resp.message;
                  }
                  
                  modal('show' , _msg , true);
                }else{
                  modal('show','Error encoutered while processing request. Error Code [R1]',true);  
                }         
              }else{
                modal('show','Process returned Unexpected. Error Code [R2]',true);  
              }
          } else {
            // We reached our target server, but it returned an error
            modal('show','Error has been encountered code [R2410]',true);
          }
        };

        request.onerror = function() {
           modal('show','Error has been encountered code [R2411]',true);  
          // There was a connection error of some sort
        };

        request.send(param);
      }

      var el = document.getElementById('syncSettings');
      var el2 = document.getElementById('syncSettingsForced');
      el.addEventListener('click',function(){
        syncSettings(false);
      });
      el2.addEventListener('click',function(){
        syncSettings(true);
      });

      var el = document.getElementById('loadCurrentSettings');
      el.addEventListener('click',function(){
        loadCurrentSettings();
      });
    })(window,document);

  function modal(method,message,closable){

    var modal = document.getElementById('cp-modal');
    
    if(method.toLowerCase() == 'show'){
      modal.style.display = 'block';
    }else if(method.toLowerCase() == 'hide'){
      modal.style.display = 'none';
    }

    if(typeof message != "undefined" && message.length >= 1){
      var div = document.querySelector('.cp-modal-text');
      div.innerHTML = message;
    }

    var closeBtn = document.getElementById('cp-modal-hide-btn');
    if(typeof closable != "undefined"){          
      closeBtn.style.display = 'block';
    }else{
      closeBtn.style.display = 'none';
    }                    
  }
  </script>
</html>