<?php

function __output($output)
{
	header('Content-type: application/json');
    echo json_encode($output);
    exit;
}


if(isset($_SERVER['REQUEST_METHOD']))
{
	switch (strtoupper($_SERVER['REQUEST_METHOD'])) {
		case 'POST':
			$_DATA = $_POST;
		break;
		
		case 'GET':
		default:
			// code...
			$_DATA = $_GET;
		break;
	}


	if(isset($_DATA['updateWANsettings']))
	{
		require_once '/www/cgi-bin/firewall/requestrules.php';
	    $OUTPUT = updateWANsettings($_DATA);
	    __output($OUTPUT);    
	}


	if(isset($_DATA['retrieveserversettings']))
	{    
		require_once '/www/cgi-bin/firewall/requestrules.php';
	    $forced_update = false;
	    if(isset($_DATA['forced'])){
	        $forced_update = true;
	    }
	    $OUTPUT = processSyncSettings($forced_update);
	    __output($OUTPUT);
	}

	if(isset($_DATA['loadcurrentfwsettings'])){
		require_once '/www/cgi-bin/firewall/requestrules.php';
	    $data = loadcurrentfwsettings();
	    __output($data);
	}    

	if(isset($_DATA['retrieveserversettings']))
	{
		require_once '/www/cgi-bin/firewall/requestrules.php';
	    $forced_update = false;
	    if(isset($_DATA['forced'])){
	        $forced_update = true;
	    }
	    $OUTPUT = processSyncSettings($forced_update);
	    __output($OUTPUT);    
	}    

	if(isset($_DATA['syncvesselsettings']))
	{
		require_once '/www/cgi-bin/syncsettings.php';
		$sync = new Syncsettings;
		$sync->process_settings();
		$sync->process_vsettings();
		$sync->process_vconfig();
		echo $sync->sync_result();
		exit;
	}

	if(isset($_DATA['RUNSYNCDEBUG']))
	{
		require_once '/www/cgi-bin/syncsettings.php';
		$sync = new Syncsettings;
		$sync->process_settings();
		$sync->api_key = 'AutoSyncDataVsettings';
		$sync->process_vsettings();	 
		$sync->api_key = 'AutoSyncDataVConfig';
		$sync->process_vconfig();	
		echo "<pre>";
		print_r($sync->_output_debug_result());
		exit;
	}


	if(isset($_DATA['RUNFIREWALL']))
	{
		if(!file_exists('/www/cgi-bin/firewall/config.php'))
		{
			__output(array(
				'status' => false,
				'message'=> 'Error has occured while loading CONFIG File, aborted process',		
			));
		}
		require_once '/www/cgi-bin/firewall/config.php';

		if(!file_exists(API_CONFIG_FILE_PATH))
		{
			__output(array(
				'status' => false,
				'message'=> 'Error has occured while loading API CONFIG File, settings was not applied to router',		
			));
		}

		if(!file_exists(DNSFILTER_PATH))
		{
			__output(array(
				'status' => false,
				'message'=> 'Error has occured while loading DNS Filter File, settings was not applied to router',		
			));
		}

		if(!file_exists(NETWORK_PATH))
		{
			__output(array(
				'status' => false,
				'message'=> 'Error has occured while loading NETWORK File, settings was not applied to router',		
			));
		}		

		ob_start();
		require_once '/www/cgi-bin/firewall/applyrules.php';
		/*
			Prerequisites
			Config must be downloaded and processed by process.php
			process.php cleans,verifies and writes data to each config file
			Applyrules will look for those files and feed to each module/api on the hardware
			list of config files used are found in config.php see DATA PATHS
		*/
		$ProcessRules = new Applyrules();
		$ProcessRules->_cleanDomainsonDNSdatabase();
		$ProcessRules->applyCurrentSettings();
		//#Uncomment to return back config
		// $ProcessRules->config();	
		$unwanted_output = ob_get_contents();
		if($unwanted_output !== '')
		{
			file_put_contents(FW_API_LOG,$unwanted_output);
		}
		ob_end_clean();	
		$OutPutResult = $ProcessRules->output();		
		Output::json($OutPutResult);
		exit;		
	}
}else{

}

//END OF process.php