<?php
error_reporting(0);
$_VERSION_INI_ = parse_ini_file('/www/version.ini');
function _hex2ip($hex){
	$tmp = $hex[0] . $hex[1];
	$ip = hexdec($tmp) . ".";
	
	$tmp = $hex[2] . $hex[3];
	$ip .= hexdec($tmp) . ".";
	
	$tmp = $hex[4] . $hex[5];
	$ip .= hexdec($tmp) . ".";
	
	$tmp = $hex[6] . $hex[7];
	$ip .= hexdec($tmp);
	
	if (strlen($hex) > 8)  $ip .= substr($hex, 8);
	
	return $ip;
}

function _hex2port($port){
	if(strpos($port, ',') !== false)
	{
		//is multiple
		$exploded = explode(':', $port);
		$tmp = array();
		foreach($port as $pk => $pv)
		{
			$tmp[] = hexdec($pv);
		}
		$portParsed = implode(',',$tmp);
	}else if(strpos($port, ':') !== false)
	{
		$exploded = explode(':', $port);
		$portParsed = hexdec($exploded[0]).':'.hexdec($exploded[1]);
		//is range
	}else if($port != 0){
		$portParsed = hexdec($port);
	}else{
		$portParsed = 0;
	}

	return $portParsed;
}
/*
crwpfwd
crwwansett
*/
$portforward_data = array();
$crew_wan_ip_address = '';
$crew_wan_subnet_mask = '';
$crew_wan_gateway_address = '';
$crew_wan_broadcast_address = '';
$crew_wan_mode = '';
$data_path = $_VERSION_INI_['firewallpath'].'/data/applied_rules.json';
if(file_exists($data_path))
{
	$config = file_get_contents($data_path);
	$parsed = @json_decode($config,true);
	if(isset($parsed['crwpfwd']) && strlen($parsed['crwpfwd']) >= 1)
	{
		$raw = explode(';',$parsed['crwpfwd']);
		foreach($raw as $key => $val){
			$portforward_data[] = explode('|',$val);
		}
	}

	if(isset($parsed['crwwansett']) && strlen($parsed['crwwansett']) >=1)
	{
		$crew_wan_settings = explode(';', $parsed['crwwansett']);
		$crew_wan_ip_address 		= isset($crew_wan_settings[1]) ?  $crew_wan_settings[1] :'';
		$crew_wan_subnet_mask 		= isset($crew_wan_settings[2]) ?  $crew_wan_settings[2] :'';
		$crew_wan_gateway_address 	= isset($crew_wan_settings[3]) ?  $crew_wan_settings[3] :'';
		$crew_wan_broadcast_address = isset($crew_wan_settings[4]) ?  $crew_wan_settings[4] :'';
		$crew_wan_mode 				= isset($crew_wan_settings[0]) ?  strtoupper($crew_wan_settings[0]) :'DHCP';		
	}
}
?>
<p><strong>WAN MODE</strong>(<?php echo $crew_wan_mode;?>)</p>
<div>
	<label><input type="radio" class="display-config wan_mode" data-value="hide" name="wan_mode" value="DHCP" <?php echo $crew_wan_mode == 'DHCP' ? 'checked' : ''?>> DHCP</label><br>
	<label><input type="radio" class="display-config wan_mode" data-value="show" name="wan_mode" value="STATIC" <?php echo $crew_wan_mode == 'STATIC' ? 'checked' : ''?>> STATIC</label>
</div>

<div id="static_config_display" style="<?php echo $crew_wan_mode == 'DHCP' ? 'display:none' : ''?>">
	<br>
	<div style="display:inline-block;width:24%;">
		<label>IP Address
			<input id="wan_ip" value="<?php echo $crew_wan_ip_address;?>" type="text" style="display:block;width:100%">
		</label>
		<br>
	</div>
	<div style="display:inline-block;width:24%;">
		<label>Subnet Mask
			<input id="wan_subnet" value="<?php echo $crew_wan_subnet_mask;?>" type="text" style="display:block;width:100%">
		</label>
		<br>
	</div>
	<div style="display:inline-block;width:24%;">
		<label>Gateway Address
			<input id="wan_gateway" value="<?php echo $crew_wan_gateway_address;?>" type="text" style="display:block;width:100%">
		</label>
		<br>
	</div>
	<div style="display:inline-block;width:24%;">
		<label>Broadcast Address
			<input id="wan_broadcast" value="<?php echo $crew_wan_broadcast_address;?>" type="text" style="display:block;width:100%">
		</label>
		<br>		
	</div>
</div>
<div>	
	<button id="process_wan_settings" data-target="" style="width:24%;" type="button">Save WAN Changes</button>
</div>
<br><br>
<p><strong>Port Forwarding</strong></p>
<div id="portforwarding_display">
	<br>
	<div style="display:inline-block;width:20%;">
		<label>Name</label>
	</div>	
	<div style="display:inline-block;width:15%;">
		<label>Protocol</label>
	</div>
	<div style="display:inline-block;width:15%;">
		<label>Source Port</label>
	</div>
	<div style="display:inline-block;width:15%;">
		<label>Destination Port</label>
	</div>
	<div style="display:inline-block;width:31%;">
		<label>IP Address</label>
	</div>	
	<hr>
	<?php if(count($portforward_data) <= 0 ):?>
	<br>
	<div style="display:inline-block;width:20%;">		
		<input type="text" style="display:block;width:100%" disabled readonly="readonly">		
	</div>	
	<div style="display:inline-block;width:15%;">		
		<input type="text" style="display:block;width:100%" disabled readonly="readonly">		
	</div>
	<div style="display:inline-block;width:15%;">		
		<input type="text" style="display:block;width:100%" disabled readonly="readonly">		
	</div>
	<div style="display:inline-block;width:15%;">		
		<input type="text" style="display:block;width:100%" disabled readonly="readonly">
	</div>
	<div style="display:inline-block;width:31%;">		
		<input type="text" style="display:block;width:100%" disabled readonly="readonly">		
	</div>	
	<?php else:?>
		<?php foreach($portforward_data as $data):?>
		<br>
		<div style="display:inline-block;width:20%;">			
			<input type="text" style="display:block;width:100%" disabled readonly="readonly">			
		</div>	
		<div style="display:inline-block;width:15%;">
			<input value="<?php echo $data[4];?>" type="text" style="display:block;width:100%" disabled readonly="readonly">			
		</div>
		<div style="display:inline-block;width:15%;">			
			<input value="<?php echo _hex2port($data[1]);?>" type="text" style="display:block;width:100%" disabled readonly="readonly">
		</div>
		<div style="display:inline-block;width:15%;">		
			<input value="<?php echo _hex2port($data[3]);?>" type="text" style="display:block;width:100%" disabled readonly="readonly">			
		</div>
		<div style="display:inline-block;width:31%;">			
			<input value="<?php echo _hex2ip($data[2]);?>" type="text" style="display:block;width:100%" disabled readonly="readonly">			
		</div>	
		<?php endforeach;?>
	<?php endif;?>
</div>

<script>
	$(document).ready(function(){

		function _saveWAN(){
			var HOST = "<?php echo buildURL('firewall/process.php');//buildURL function defined in syncbutton.php ?>";
			var wan_ip = $('#wan_ip').val();
			var wan_subnet = $('#wan_subnet').val();
			var wan_gateway = $('#wan_gateway').val();
			var wan_broadcast = $('#wan_broadcast').val();
			var wan_mode = $('.wan_mode:checked').val();
			var _saveWAN;

			modal('show','Settings Up WAN Settings Please do not close your browser',false,true);
			_saveWAN = $.ajax({
				url: HOST,
				type: "POST",				
				data:{
					wan_ip : wan_ip,
					wan_subnet : wan_subnet,
					wan_gateway : wan_gateway,
					wan_broadcast : wan_broadcast,
					wan_mode : wan_mode,
					updateWANsettings : true
				}
			});
		
			_saveWAN.done(function (response){
				var message = '';
				if(response.status === false){
					message += "ERROR!<br>"+response.message;
				}else{
					message += response.message;
				}
				modal('show',message,true);
			});
		
			_saveWAN.fail(function (response){
				modal('show','An error has occured while applying WAN Settings',true);
			});
		
			_saveWAN.always(function (response) {
				_saveWAN = false;
			});			
		}
		$('.display-config').on('click',function(e){
			var functioncall = $(this).attr('data-value');
			$('#static_config_display')[functioncall]();
		});

		$(document).on('click','#process_wan_settings',function(e){
			e.preventDefault();			

			if(confirm('Are you sure you want to Update WAN Settings?')){
				_saveWAN();	
			}
			
		});
	});
</script>