<?php
/************************************************************************************************
ACFW GENERATOR GUI

WRITTEN BY JOSE MARI REYES

TEST GUI FOR GENERATING ADVANCE FIREWALL COMMAND STRING

HISTORY:

	1-28-2019	INITIAL VERSION
	2-27-2019	DOMAIN SUPPORT
        11-06-2019	FIXED TCP+UDP ISSUE.  NOW FULLY SUPPORT TCP+UDP
	
*************************************************************************************************/

require_once("acfw");

$source 	= 0;
$dest   	= 0;
$port       = 0;
$cmdlist    = "";



		if (isset($_REQUEST['Submit']) == true)
		{
		
				$mode    = $_REQUEST['SEL_MODE'];
				$chain 	 = $_REQUEST['SEL_CHAIN'];
				$source  = $_REQUEST['TXTSRC'];
				$dest    = $_REQUEST['TXTDEST'];
				$proto   = $_REQUEST['SEL_PROTO'];
				$sd      = $_REQUEST['SEL_SDP'];
				$port	 = $_REQUEST['TXT_PORT'];
				$target  = $_REQUEST['SEL_TARGET'];
				$cmdlist = $_REQUEST['TXT_CMD'];
				
				echo ">>>>$dest\n";
				
				$op = $mode . $chain . $proto . $sd . $target;
				
				$ophex = bindec($op);
				$ophex = dechex($ophex);
				
				if (strlen($source) < 1) $source = 0;
				if (strlen($dest) < 1) $dest = 0;
				if (strlen($port) < 1) $port = 0;
				
				
				if ($source != "0") 
				{	
					if ($target == "11") 
						$src = $source;
					else 
					{
						if (ip2long($source) === false)
							$src = $source;
						else	
							$src = ip2hex($source); 
					}
				}
				else
				 	$src = 0;
				
				if ($dest != "0") 
				{	
					if (ip2long($dest) == false) 
						$dst = $dest;
					else	
						$dst = ip2hex($dest); 
				}
				else
				 	$dst = 0;
				
				
				$hexport = "";
				if (strpos($port, ":") != 0)
				{
					$tmp = explode(":", $port);
					$hexport = dechex($tmp[0]) . ":" . dechex($tmp[1]);
				}
				elseif (strpos($port, ",") != 0) //port list
				{
					echo "[$port]\n";
					$tmp = explode(",", $port);
					//print_r($tmp);
					for ($i = 0; $i < count($tmp); $i++)
					{
						$v = dechex($tmp[$i]);
						//echo "---->" . $v . ",";
						$hexport .= "$v,";
					} 
					
					$hexport = trim($hexport, ",");
					
				}
				else
					$hexport = dechex($port);
				
				$cmd = strtoupper("$ophex|$src|$dst|$hexport");
				
				
				$ipcom = ident_op($ophex, $src, $dst, $hexport);
				
				echo "[$ipcom]\n";
				$cmdlist .= "$ipcom>$cmd\n";
		}
	
	
	if (isset($_REQUEST['CMD_EXEC']) == true)
	{
			
			$cmdlist = $_REQUEST['TXT_CMD'];
			
			echo "$cmdlist";
			
			$v = explode("\n", $cmdlist);
			
			print_r($v);
			
			$rules = "";
			
			for ($i = 0; $i < count($v)-1; $i++)
			{

				if (strpos($v[$i], '>') !== false)
				{
					$tmp = explode(">", $v[$i]);
					//print_r($tmp);
				
			    		$rules .= trim($tmp[1], "\r\n") . ";";
				}	
			}
			
			echo "===$rules";
			proc_adv_firewall($rules, $read = 0);
	
			
	
	}
	
	
function ip2hex($ip)
{
$hexip = "";
$sw = 0;

	if (strpos($ip, "/") != 0) //subnet
	{
		$tmp = explode("/", $ip); //get the ip part
		$oct = $tmp[0];
		$sw = 1;
	}
	else
	 	$oct = $ip;  //just point to ip
	
	
	$oct = explode(".", $oct); 
	
	$hexip  = str_pad(dechex($oct[0]), 2, "0", STR_PAD_LEFT);
	$hexip .= str_pad(dechex($oct[1]), 2, "0", STR_PAD_LEFT);
	$hexip .= str_pad(dechex($oct[2]), 2, "0", STR_PAD_LEFT);
	$hexip .= str_pad(dechex($oct[3]), 2, "0", STR_PAD_LEFT);
	
	
	
	$hexip .= ($sw == 1) ? "/" . $tmp[1] : "";
	
	return $hexip;
	
}



?>
<style type="text/css">
<!--
.style1 {
	font-family: Arial, Helvetica, sans-serif;
	font-weight: bold;
	font-size: 16px;
}
.style2 {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 16px;
}
.style4 {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 24px;
	font-weight: bold;
	color: #666666;
}
-->
</style>





<form id="form1" name="form1" method="post" action="">
  <table width="90%" border="0" align="center" cellpadding="0" cellspacing="1">
    <tr>
      <td height="19" colspan="2" bgcolor="#CCCCCC">&nbsp;</td>
    </tr>
    <tr>
      <td height="36" colspan="2"><span class="style4">CrewCommWifi Advance Firewall Composer </span></td>
    </tr>
    <tr>
      <td bgcolor="#CCCCCC" class="style2">&nbsp;</td>
      <td bgcolor="#CCCCCC">&nbsp;</td>
    </tr>
    <tr>
      <td class="style2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td width="21%" class="style2"><span class="style2">MODE</span></td>
      <td width="79%"><label>
        <select name="SEL_MODE" id="SEL_MODE">
          <option value="0" <?php if ($mode == 0) echo 'selected="selected"'; ?>>INSERT</option>
          <option value="1" <?php if ($mode == 1) echo 'selected="selected"'; ?>>APPEND</option>
        </select>
      </label></td>
    </tr>
    <tr>
      <td class="style2">CHAIN</td>
      <td><label>
        <select name="SEL_CHAIN" id="SEL_CHAIN">
          <option value="00" <?php if ($chain == "00") echo 'selected="selected"'; ?>>INPUT</option>
          <option value="01" <?php if ($chain == "01") echo 'selected="selected"'; ?>>FORWARD</option>
          <option value="10" <?php if ($chain == "10") echo 'selected="selected"'; ?>>OUTPUT</option>
        </select>
      </label></td>
    </tr>
    <tr>
      <td class="style2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td class="style2">SOURCE</td>
      <td><label>
        <input name="TXTSRC" type="text" id="TXTSRC" value="<?php echo $source; ?>" size="100" />
        <span class="style2">(If RAW The source becomes the Firewall Raw parameters)</span></label></td>
    </tr>
    <tr>
      <td class="style2">DESTINATION</td>
      <td><label>
        <input name="TXTDEST" type="text" id="TXTDEST" value="<?php echo $dest; ?>" size="100" />
      </label></td>
    </tr>
    <tr>
      <td class="style2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td class="style2">PROTOCOL</td>
      <td><label>
        <select name="SEL_PROTO" id="SEL_PROTO">
          <option value="00" selected="selected" <?php if ($proto == "00") echo 'selected="selected"'; ?>>---</option>
          <option value="01" <?php if ($proto == "01") echo 'selected="selected"'; ?>>TCP</option>
          <option value="10" <?php if ($proto == "10") echo 'selected="selected"'; ?>>UDP</option>
          <option value="11" <?php if ($proto == "11") echo 'selected="selected"'; ?>>TCP+UDP</option>
        </select>
      </label></td>
    </tr>
    <tr>
      <td class="style2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td class="style2">PORT TYPE </td>
      <td><label>
      <select name="SEL_SDP" id="SEL_SDP">
        <option value="0" <?php if ($sd == "0") echo 'selected="selected"'; ?>>DESTINATION PORT</option>
        <option value="1" <?php if ($sd == "1") echo 'selected="selected"'; ?>>SOURCE PORT</option>
      </select>
      </label></td>
    </tr>
    <tr>
      <td class="style2">PORT </td>
      <td><label>
        <input name="TXT_PORT" type="text" id="TXT_PORT" value="<?php echo $port; ?>" size="50" />
      </label></td>
    </tr>
    <tr>
      <td class="style2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td class="style2">TARGET</td>
      <td><label>
        <select name="SEL_TARGET" id="SEL_TARGET">
          <option value="00" <?php if ($target == "00") echo 'selected="selected"'; ?>>ACCEPT</option>
          <option value="01" <?php if ($target == "01") echo 'selected="selected"'; ?>>DROP</option>
          <option value="10" <?php if ($target == "10") echo 'selected="selected"'; ?>>REJECT</option>
          <option value="11" <?php if ($target == "11") echo 'selected="selected"'; ?>>RAW</option>
        </select>
      </label></td>
    </tr>
    <tr>
      <td class="style2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td bgcolor="#CCCCCC" class="style2">&nbsp;</td>
      <td bgcolor="#CCCCCC"><label>
        <input name="Submit" type="submit" class="style1" value="Submit" />
      </label></td>
    </tr>
    <tr>
      <td height="28" class="style2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td class="style2">OP FIELD BITS </td>
      <td><span class="style1"><?php echo "$op ==> $ophex"; ?></span></td>
    </tr>
    <tr>
      <td class="style2">FINAL ACFW COMMAND </td>
      <td><label class="style1"><?php echo "$cmd"; ?></label></td>
    </tr>
    <tr>
      <td class="style2">IPTABLE CMD </td>
      <td class="style1"><?php echo "$ipcom" ?>;</td>
    </tr>
    <tr>
      <td class="style2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td class="style2">FILTERS </td>
      <td><textarea name="TXT_CMD" cols="120" rows="10" class="style2" id="TXT_CMD"><?php echo $cmdlist; ?></textarea>
        <label>
        <input name="CMD_EXEC" type="submit" class="style1" id="CMD_EXEC" value="Save Filters" />
      </label></td>
    </tr>
    <tr>
      <td class="style2">&nbsp;</td>
      <td><label></label></td>
    </tr>
  </table>
  <p>&nbsp;</p>
</form>
 
